/* MP_DATA.C  data input and storage routines */

#include <conio.h>
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include "defines.h"

extern PLAYER player[MAXFL][MAXSZ];

extern int NP[];           /* number of players in each flight */
extern char mark[];        /* single shaded block */
extern char namefield[];   /* 19 marks */
extern char hcpfield[];
extern char scorefield[];
extern int no_space;       /* flag for get_string() */

extern int norm_attr, high_attr;
extern int recalc[];
extern int left, top, right, bottom;
extern int numflights;

/* function prototypes */
void
  chk(int),
  correct(int, int),
  delete(int, int),
  init_kb_screen(void),
  kb_entry(void),
  init_flights_screen(void),
  init_score_screen(void),
  score_entry(void),
  scroll(int,int,int,int,int),
  show_msgs(int);
int
  correct_hcp(int *),
  correct_name(char *),
  correct_scores(char *),
  error_msg(char *, int, int),
  getline(FILE *,char *),
  read_char(int,int);

extern void
  calc_all(void),
  normal_exit(int),
  rect(int, int, int, int, int, int),
  show_data(int,int,int),
  std_screen(void),
  write_data(FILE *);
extern int
  find(char *, int *),
  get_string(char *, char *, char *, int, int),
  menu_select(int,int,int,int,int,char *,int,int,int,int,int,int,
                int,int,int,int *,char **);

/* ====================================================================== */
void
init_score_screen()       /* instructions for score_entry() */
{
  int col2 = 23, col3 = 26, col4 = 29;
  char *instruction[] = {
        "    SCORE ENTRY",
        "",
        "Enter desired scores,",
        "then return to the",
        "main menu by entering",
        "a blank name or by",
        "pressing Esc.",
        "",
        "Scores may be entered",
        "only for players on the",
        "current roster, since",
        "it is not possible to",
        "add names now."};
  int i;

  std_screen();
  textattr(high_attr);
  window(28,1,80,1);
  clrscr();
  gotoxy(8,1); cputs("Name");
  gotoxy(col2-1,1); cputs("Hcp");
  gotoxy(col3,1); cputs("Flt");
  gotoxy(col4+7,1); cputs("Scores");
  window(2,2,26,24);
  textattr(high_attr);
  clrscr();
  for (i=0; i<13; i++) {
    gotoxy(2,i+2);
    cputs(instruction[i]);
  }
  window(28,2,80,25);
  textattr(norm_attr);
  clrscr();
}

/* ---------------------------------------------------------------------- */
void
score_entry(void)
{
  int col1 = 2, col2 = 23, col3 = 26, col4 = 29;
  int row = 1;
  int c,i,f,k,r;
  char pname[21], scores[25], h[3], flt[3];
  char *blank_name = "                     ";
  int hcp=0, flight=0;
  FILE *fp;
  int changed[MAXFL];  /* flags for calculation needed */
  int changeflag = 0;  /* set if any changes made */
  extern char datafile[];
  int flght[10], index[10];

  for (i=0; i<MAXFL; i++) changed[i] = 0;
  init_score_screen();           /* set up entry screen */

  while(1) {
    r = get_string("",pname,namefield,col1, row);
    if (!r) break;
    r = findn(pname,flght,index);
    if (r == -1) {
      error_msg("Not found in entry list",27+col2-2,1+row);
      continue;
    }
    else if (r > 0) {
      r = pick_one(1+row, r, flght, index);
      if (r == -1)
        continue;
    }
    flight = flght[r];
    strcpy(pname, player[flight][index[r]].name);
    hcp = player[flight][index[r]].hcp;
    gotoxy(col1,row);
    cputs(blank_name);
    gotoxy(col1,row);
    cputs(pname);
    gotoxy(col2,row);
    cprintf("%d",hcp);
    gotoxy(col3,row);
    cprintf("%d",flight);
    if (player[flight][index[r]].scores[0] != 0) {
      error_msg("Scores already entered",27+col2-2,1+row);
      gotoxy(col1,row);
      cputs("                                        ");
      continue;
    }
get_scores:
    no_space = 1;       /* ignore user-entered spaces */
    c = get_string("",scores,scorefield,col4,row);
    no_space = 0;       /* reset flag */
    if (c == 0)         /* scores already entered */
      continue;
    if (c>0 && c<24) {
      error_msg("18 scores required",27+col4-18,1+row);
      goto get_scores;
    }
    enter_scores(flight,index[r],scores);
    changed[flight] = 1;
    changeflag = 1;
    row++;
    if (row == 24) {
      scroll(28,2,79,24,norm_attr);
      row = 23;
    }
  }
  if (changeflag) {          /* update and save data if any entered */
    clrscr();
    for (k=0; k<MAXFL; k++)
      if (changed[k]) {
        set_gnp(k);
        calc_results(k);
      }
    fp = fopen(datafile,"w");  /* automatic save after every kb_session */
    write_data(fp);
    fclose(fp);
    changeflag = 0;
  }
}

/*---------------------------------------------------------------------------*/
enter_scores(int flight, int i, char *scores)
{
  int g,h;
  extern ndx[];

  strcpy(player[flight][i].scores,scores);
  if (player[flight][i].hcp < 0)    /* if temporary hcp, use Callaway */
    player[flight][i].hcp = callaway(scores);
}

/*---------------------------------------------------------------------------*/
error_msg(char *msg, int col, int row)  /* col,row absolute coordinates */
{
  char buf[160], msg1[80];
  int length,c;
  extern int mono;
  struct text_info text;

  gettextinfo(&text);
  window(1,1,80,25);
  length = strlen(msg) + 2;
  if (col+length > 80)           /* not enough room for message */
    return 0;
  msg1[0] = ' ';                 /* add spaces at start and end of msg */
  strcpy (&msg1[1],msg);
  strcat(msg1," ");
  gettext(col, row, col+length, row, buf);   /* save current screen area */
  if (!mono)
    textattr(16*4+7);
  else
    textattr(norm_attr);
  gotoxy(col,row);
  cputs(msg1);
  gotoxy(wherex()-1,row);         /* in case cursor is on */
  c = getch();
  puttext(col,row,col+length,row,buf);
  textattr(norm_attr);
  window(text.winleft,text.wintop,text.winright,text.winbottom);
  return c;
}

/*---------------------------------------------------------------------------*/
void
chk(int flight)
{
  int i,j,f,k,n;
  int start_index, stop_index;

  asort(flight);
  show_msgs(flight);
  start_index = 0;
  stop_index = MIN(24,NP[flight]-1);
  for (i=start_index; i<=stop_index; i++)
    show_data(flight, start_index+i, i+1);

  while (1) {
    while (kbhit())
      getch();                  /* clear kb buffer */
    switch(getkey()) {
      case ESC:           /* Esc or CR returns to main menu */
      case CR:
        return;

      case PgUp:
        if (flight == 0)
          flight = numflights-1;
        else
          flight--;
        chk(flight);       /* shift to next smaller nonempty flight */
        return;

      case PgDn:
        if (flight == numflights-1)
          flight = 0;
        else
          flight++;
        chk(flight);        /* shift to next larger nonempty flight */
        return;
    }
  }
}

/* ---------------------------------------------------------------------- */
void
show_msgs(int flight)
{
  int i, num_msgs=6;
  char *msg[] = {
    "      FLIGHT  ",
    "",
    "  PgUp = Prev Flt.",
    "  PgDn = Next Flt.",
    "",
    "Esc returns to menu"
  };

  std_screen();
  window(2,2,26,24);
  textattr(high_attr);
  clrscr();
  for (i=0; i<num_msgs; i++) {
    gotoxy(2,i+2);
    cputs(msg[i]);
  }
  gotoxy(2+14,2);
  cprintf("%d",flight);
  window(left,top,right,bottom);
  textattr(norm_attr);
  clrscr();
}

/* ---------------------------------------------------------------------- */
void
correct(int flight, int j)
{
  int col =  41, row = 3;
  int scol = 27+19, ecol = 27+34, srow = 7, erow = 13;
  int norm_attr1=WHITE+16*BROWN;
  int high_attr1=WHITE+16*BLACK;
  int tag_attr1=YELLOW+16*BROWN;
  int tag_high1=YELLOW+16*BLACK;
  char *item[] = { "  Name   ",
                   "  Hcp    ",
                   "  Scores ",
                   "  Accept ",
                   "  Delete "};
  int numitems = 5, tag_indx = 2;
  static int current = 0;
  int selection;
  int ltr[] = {'n','h','s','a','d'};
  int i,hcp;
  char pname[21],scores[25];

  if (mono) {
    norm_attr1 = tag_attr1 = norm_attr;
    high_attr1 = tag_high1 = high_attr;
  }

  textattr(norm_attr);
  window(left,top,right,bottom);
  clrscr();
  window(1,1,80,25);
  gotoxy(col,row);
  cprintf("  Name: %s",player[flight][j].name);
  gotoxy(col,row+1);
  cprintf("   Hcp: %2d",player[flight][j].hcp);
  gotoxy(col,row+2);
  if (player[flight][j].scores[0] == '\0')
    cputs("Scores: None entered");
  else
    cprintf("Scores: %s",player[flight][j].scores);

  while (1) {
    selection = menu_select(scol,srow,ecol,erow,1,"Correct:",norm_attr1,
      high_attr1,tag_attr1,tag_high1,tag_indx,numitems-1,current,2,2,ltr,item);
    if (selection == 27 || selection == 3)
      break;
    if (selection == 0) {
      i = correct_name(pname);
      if (i) {
        recalc[flight] = 1;
        strcpy(player[flight][j].name,pname);
        gotoxy(col+8,row);
        cputs(pname);
      }
      current = 1;
    }
    else if (selection == 1) {
      i = correct_hcp(&hcp);
      if (i) {
        recalc[flight] = 1;
        player[flight][j].points += (hcp - player[flight][j].hcp);
        player[flight][j].net = player[flight][j].gross - hcp;
        player[flight][j].hcp = hcp;
        gotoxy(col+8,row+1);
        clreol();
        cprintf("%2d",hcp);
      }
      current = 2;
    }
    else if (selection == 2) {
      i = correct_scores(scores);
      if (i) {
        recalc[flight] = 1;
        enter_scores(flight,j,scores);       /* change scores, gross, net */
        gotoxy(col+8,row+2);
        cprintf("%s",scores);
      }
      current = 3;
    }
    else if (selection == 4) {
      i = error_msg("Delete this entry (Y/N)?",41,16);
      if (toupper(i) != 'Y')
        break;
      delete(flight,j);
      recalc[flight] = 1;
      break;
    }
  }
}

correct_name(char *pname)
{
  int r, col1 = 41, row = 16;
  int flight;
  int ret_val = 0;

  textattr(norm_attr);
  window(1,1,80,25);
  r = get_string("Name",pname,namefield,col1, row);
  if (!r)
    goto ret;
  if (find(pname,&flight) != -1) {
    error_msg("Already entered",col1,row+1);
    goto ret;
  }
  ret_val = 1;
ret:
    gotoxy(30,row);
    clreol();
    return ret_val;
}

correct_hcp(int *hcp)
{
    int r;
    int col1 = 41, row = 16;
    char h[4];

  window(1,1,80,25);
  textattr(norm_attr);
    r = get_string("Handicap",h,hcpfield,col1,row);
    if (r) {
      *hcp = atoi(h);
      if (*hcp > 40) *hcp = 40;
    }
    gotoxy(30,row);
    clreol();
    return r;
}

correct_scores(char *scores)
{
    int r;
    int col1 = 41, row = 16;
    int i,ret_val = 1;

  window(1,1,80,25);
  textattr(norm_attr);
  no_space = 1;       /* ignore user-entered spaces */
  r = get_string("Scores",scores,scorefield,col1,row);
  no_space = 0;       /* reset flag */
  if (r == 0) {
    ret_val = 0;
    goto ret;
  }
  if (r < 0) r = -r;
  if (r>0 && r<24) {
    error_msg("18 scores required",col1,row+1);
    ret_val = 0;
    goto ret;
  }
  for (i=0; i<24; i++) {
    if (i==3 || i==7 || i==11 || i==12 || i==16 || i==20)
      continue;
    if (!isdigit(scores[i])) {
      error_msg("Invalid score",col1,row+1);
      ret_val = 0;
      goto ret;
    }
  }
ret:
    gotoxy(30,row);
    clreol();
    return ret_val;
}

void
delete(int flight, int index)
{
  int i;

  if (index >= NP[flight])
    return;
  NP[flight]--;
  if (NP[flight] == 0) {
    numflights = 0;
    return;
  }
  for (i=index; i<NP[flight]; i++)
    player[flight][i] = player[flight][i+1];
}

/* ---------------------------------------------------------------------- */
int
getline(FILE *fp, char *s)
{
  char ch, *p=s;

  while((ch = fgetc(fp)) == ' ')
    ;
  if (ch == '\n' || ch == EOF) {
    s[0] = '\0';
    return 0;        /* blank line */
  }
  *p++ = ch;
  while (1) {
    ch = fgetc(fp);
    if (ch == '\n' || ch == EOF)
      break;
    *p++ = ch;
  }
  *p = '\0';
  return 1;           /* non_blank line */
}

/*---------------------------------------------------------------------------*/
void
scroll(int left, int top, int right, int bottom, int attr)
{
  _AH = 6;
  _AL = 1;              /* scroll one line */
  _BH = attr;
  _CH = top-1;
  _CL = left-1;
  _DH = bottom-1;
  _DL = right-1;
  geninterrupt(0x10);
}

